% Copyright (c) 2010 Iris Yan

% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.

% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

function [ time_WLAN,breakdown ] = HTCE( beta,Et,R,sigma,tau_i,tau_o,P_b,v,d,er )

        l_OM = sqrt(R^2-(d/2).^2);
        RSS_M=10*log10(Et)-10*beta*log10(l_OM);
        d_R=1/2*d;
        r = sqrt(v^2*tau_o^2+R^2-v*tau_o*R*sqrt(2*(1-cos(pi-pi*P_b))))*(1-er);
        RSS_HTCE = 10*log10(Et)-10*beta*log10(r);
        if l_OM<r %Condition C1
            d_r=sqrt(r^2-l_OM^2);
            d_b=d_R-d_r;
        else %Condition C2
            d_b=d_R;
        end
        noise = getnoise(sigma);
        RSS_M_est= RSS_M+noise;
        l_OM_est=10^((10*log10(Et)-RSS_M_est)/10/beta);
        if l_OM_est<R
        d_R_est = sqrt(R^2-l_OM_est^2);
        d_predict_est = d_R_est-d_R*(1-er)+v*tau_o;
        else  d_R_est = 0;
            d_predict_est = 0;
        end
        if l_OM_est<r %Condition C1
            noise2 = getnoise(sigma);
            RSS_HTCE_est = RSS_HTCE+noise2;
            r_est = 10^((10*log10(Et)-RSS_HTCE_est)/10/beta);
            if r_est>=R
                d_handover = d_predict_est;
                d_b_est=0;
            elseif r_est<=l_OM_est
                d_b_est=d_R;
                if d_predict_est>d_R
                    d_handover = d_predict_est;
                else d_handover = d_R;
                end  
            else
            d_r_est=sqrt(r_est^2-l_OM_est^2);
            d_b_est=d_R-d_r_est;
            if d_predict_est>d_b_est
                d_handover = d_predict_est;
            else d_handover = d_b_est;
            end
            end
        else %Condition C2
            if l_OM_est>=R
                d_handover = 0;
                d_b_est=0;
            else
            d_b_est = d_R_est;
            if d_predict_est>d_b_est
                d_handover = d_predict_est;
            else d_handover = d_b_est;
            end
            end
        end
        if d_handover<v*tau_o
        breakdown = 1;
        else breakdown = 0;
        end
        if d_handover<d
        time_WLAN=(d-v*tau_i-d_handover+v*tau_o)/v;
        else time_WLAN=0;
        end

