% Copyright (c) 2010 Iris Yan

% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.

% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

clear all
R=150;
Et=500;
tau_o=2;
beta=3.5;
d_pos=120;
d_neg=140;
phai=sqrt(d_pos*d_neg);
hy=10*beta*log10(phai/d_pos);
RSS0=10*beta*log10(phai);
RSS_HY=RSS0+hy;
r_HY0=10^(RSS_HY/10/beta);
for i=1:3
    r_HY(i)=120+10*(i-1);
end
v0=[10:150];
%
% [v0,r_HY]=meshgrid(1:150,120:R);
%
v=v0.*5/18;
x=v.*tau_o;

for i=1:3  
    for j=1:length(x)
if x(j)<=(R-r_HY(i))
    p2(i,j)=0;
elseif x(j)>=sqrt(R^2-r_HY(i).^2)
    p2(i,j)=1;
else p2(i,j)=1-1/pi*(acos(2*r_HY(i).^2/R^2-(R^2-r_HY(i).^2-x(j).^2).^2/2./x(j).^2/R^2-1));
end
    end
end

plot(v0,p2(1,:),'-bo');
hold on
plot(v0,p2(2,:),'-r');
hold on
plot(v0,p2(3,:),'--bx');
hold on
legend('r_{HY}=120','r_{HY}=130','r_{HY}=140');
grid  ('on')
xlabel('Velocity (km/h)')
ylabel('Connection Breakdown Probability')
title ('Theoretical Analysis')
