% Copyright (c) 2010 Iris Yan

% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.

% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

% clear all variables
clear all

% Define the standard deviation
sigma=4.3;
beta=3.5;
t=[1:0.5:20];
v=20;
x=[1:0.5:100];
Px=20;
PL=40;

% White Gaussian random variable
for k = 1: length(x)
  for ij=1:length(t) 
      xi=sigma*randn(1); 
      r(ij,k)=sqrt((sqrt(150^2-x(k)^2)-v*t(ij)).^2+(x(k)^2));
%RSS(ij,k)= 500.*r(ij,k).^(-beta).*(10.^(0.1.*xi));
      RSS(ij,k)=Px-PL-10*beta*log10(r(ij,k))+xi;
  end
end
% plot the results

mesh(x,t,RSS);
hold on

% mesh(x,t,10*log10(RSS_mean));
% grid on 

