% Copyright (c) 2010 Iris Yan

% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.

% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

function [ x_P,y_P,theta ] = samplepoints( x1,y1,x2,y2 )
%This function generates sampling points along the moving trajectory

total_distance=sqrt((y2-y1)^2+(x2-x1)^2);
l=1;
gradient=(y2-y1)/(x2-x1);
theta=atan(gradient);
for i=1:length(floor(total_distance))
    x_P(i)=l*cos(theta)+x1;
    y_P(i)=l*sin(theta)+y1;
    l=l+1;
end
    

